#Script para el calculo
#de la Firma del Sujeto

#Importo las librerias que voy a usar
library("RWeka")
library("tm")

#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")
#---------------------------------------------------
print("OPCION 2 NGRAM")
#FUNCIONES----------------------------------------------------
#Creo funcion que me crea  tokens de dos y tres tags
TFGGramTokenizer <-function(x) NGramTokenizer(x,Weka_control(min=2,max=6))

checkTerm <- function(termino,vector_terminos){  
  resultado <- 0
  for(long in 1:length(vector_terminos)){
    if(termino == vector_terminos[long]){
      resultado <- 1
    }
  }
  return(resultado)
}
#-----------------------------------------------------------
matriz_tags <-scan("Tags/matrizTags.txt",what=character(0),sep="\n",flush=FALSE, fill=FALSE)


matriz <- gsub("\\t"," ", matriz_tags)

#Creo una lista donde separo cada uno de los sujetos
sujeto <- list(list())
sujeto[[1]][1] <- matriz[1]
j <- 1
i<-integer()
col<-2
longitud <- length(matriz)
for(i in 2:longitud){
  if(matriz[i]==","){
    j<-j+1
    col<-1
    sujeto[[j]]<-""
  }else{
    sujeto[[j]][col]<-matriz[i]
    col<-col+1
  }
}
#Guardo en la variable longitud el numero de sujetos
longitud <- length(sujeto)
corpus <- list()
for(i in 1:longitud){
  corpus[[i]] <- Corpus(VectorSource(sujeto[[i]]))
}


#Tengo el corpus de los documentos
#Ahora creo nuevos vectores con los n-gramas
tdm <- list()
tdm.norm <- list()
tdm.norm.05 <- list()
for(i in 1:longitud){
  tdm[[i]] <- TermDocumentMatrix(corpus[[i]][1], control=list(weight= function(x) weightSMART(x,spec="ntc"),tokenize=TFGGramTokenizer))
  mat_dim <- strsplit(corpus[[i]][[1]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
  long = length(mat_dim[[1]])
  tdm.norm[[i]] <- tdm[[i]]
  tdm.norm[[i]]$v <- tdm[[i]]$v/long
  
  for(j in 2:length(corpus[[i]])){
    mat_dim <- strsplit(corpus[[i]][[j]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
    long <- length(mat_dim[[1]])  
    tdm1 <- TermDocumentMatrix(corpus[[i]][j], control=list(weight= function(x) weightSMART(x,spec="ntc"),tokenize=TFGGramTokenizer))
    tdm1.norm <- tdm1
    tdm1.norm$v <- tdm1$v/long 
    tdm.norm[[i]] <- c(tdm.norm[[i]],tdm1.norm)
  }
  tdm.norm.05[[i]] <- removeSparseTerms(tdm.norm[[i]],0.3)
}

longitud <- length(sujeto)
tdm.glob <- tdm.norm.05[[1]]
corpus <- list()
for(i in 2:longitud){
  tdm.glob <- c(tdm.glob,tdm.norm.05[[i]])
}


#tdm.norm.05 <- tdm.glob
vector.terminos <- list()
for(i in 1:longitud){
  vector.terminos[[i]]<- tdm.norm.05[[i]]$dimnames$Terms
}
pesos_terms <- list(vector())
lista_terminos <- list(data.frame())
pesos <- 1
#Calculo el area del box plot

write("CALCULO DE LAS AREAS DE LOS TERMINOS\n\n",file="Firma/Terminos_area.dat",append=FALSE)  
for(j in 1:longitud){
  texto <- paste("\nProceso de selecion de terminos del sujeto: ", j,"")
  print(texto)
  write(texto,file="Firma/Terminos_area.dat",append=TRUE)
  lista_terminos[[j]]<-0
  for(i in 1:length(vector.terminos[[j]])){  
      contador <- 1
      pesos_box <- list()
      pesos_box[[j]]<- boxplot(tdm.norm.05[[j]][vector.terminos[[j]][i]]$v)$stats[,1] 
      for(sujeto in 1:longitud){
        if(sujeto != j){
          resultado <- 0
          resultado = checkTerm(vector.terminos[[j]][i],vector.terminos[[sujeto]])
          if(resultado == 1){
            pesos_box[[sujeto]]<-  boxplot(tdm.norm.05[[sujeto]][vector.terminos[[j]][i]]$v)$stats[,1]
          }else{
            pesos_box[[sujeto]] <- c(-50*contador,-50*contador,-50*contador,-50*contador,-50*contador)
            contador <- contador + 1
          }
        }
        
      }
      
      vector_medidas_alta <- vector()
      vector_medidas_baja <- vector()
      cont <- 1
      vector_medidas_alta[cont] <-  pesos_box[[j]][4]
      vector_medidas_baja[cont] <-  pesos_box[[j]][2]
      #Calculo el area entre los box plot
        for(suj in 1:longitud){
          if(suj != j){
              cont <- cont + 1        
              vector_medidas_alta[cont] <-  pesos_box[[suj]][4]
              vector_medidas_baja[cont] <-  pesos_box[[suj]][2]             
          }
        }
        area<-0
        indice1<- which(vector_medidas_alta == max(vector_medidas_alta))
        x1 <- vector_medidas_alta[indice1]
        y1 <- vector_medidas_baja[indice1]
        vector_medidas_alta[indice1] <- (-100)
        vector_medidas_baja[indice1] <- (-100)
        for(indices in 2:longitud){
          indice2 <- which(vector_medidas_alta == max(vector_medidas_alta))[1]
          x2 <- vector_medidas_alta[indice2]
          y2 <- vector_medidas_baja[indice2]
          vector_medidas_alta[indice2] <- (-100)
          vector_medidas_baja[indice2] <- (-100)
          #Calculo area
          area.nueva <- (x1 - x2)
          area <- area +  area.nueva
          #Calculo nuevo cuadrado
          if(x2 <= y1 ){
            x1 <- x2
            y1 <- y2
          }else if(y1 >= y2){
            x1 <- y1
            y1 <- y2
          }else{
            x1 <- y2        
          }
          for(iterador in 1:length(vector_medidas_alta)){
            if(vector_medidas_alta[iterador]>x1){
              vector_medidas_alta[iterador] <- x1
            }
          }
        }
        area.nueva <-  (x1 -y1)
        area <- area + area.nueva
        texto <- paste("Termino: ",vector.terminos[[j]][i]," Area: ",area)
        lista_terminos[[j]][vector.terminos[[j]][i]] <- data.frame(area)
        #print(texto)
        write(texto,file="Firma/Terminos_area.dat",append=TRUE)  
  }
}
tdm_elegidas <- vector()
termino <- 1

for(i in 1:longitud){
  contador <- 1
  for(j in 2: length(lista_terminos[[i]])){    
    if(lista_terminos[[i]][j]>100 && contador < 40/longitud){
      tdm_elegidas[termino]<- names(lista_terminos[[i]][j])
      termino<- termino + 1
      contador <- contador +1
    }
  }
}
for(i in 1:longitud){
  if(length(tdm_elegidas)>40){
    break;
  }
  for(j in 2: length(lista_terminos[[i]])){    
    if(lista_terminos[[i]][j]>50 && contador < 40/longitud){
      tdm_elegidas[termino]<- names(lista_terminos[[i]][j])
      termino<- termino + 1
      contador <- contador +1
      if(length(tdm_elegidas)>40){
        break;
      }
    }
  }
}

v.ter <- as.data.frame(lista_terminos[[1]])
ordenar<-sort(v.ter,decreasing=TRUE)
for(i in 2:length(ordenar)){
  if(length(tdm_elegidas)>40){
    break;
  }  
    encontrado <-0
    if(ordenar[[i]]<50){
      for(iterador in 1:length(tdm_elegidas)){
        
        if(tdm_elegidas[iterador]==names(ordenar[i])){
          encontrado <- 1
          break;    
        }
           
      }
      if(encontrado == 0){
      ter <- names(ordenar[i])
      ter <- gsub('\\.'," ",ter)
      tdm_elegidas[termino]<- ter      
      termino<- termino + 1
      }
    }
}



write(as.vector(tdm_elegidas[1:40]),file="Firma/firma.dat",append=FALSE)
print("Firma creada correctamente")

#wordMatrix <- as.data.frame(t(as.matrix(tdm_elegidas)))
#box <- boxplot(wordMatrix, las=2)
#box <- boxplot(wordMatrix[[2]], las=2)