library(ggplot2)
library(gcookbook)

#Type: (TAGS o FW)
type  <- vector()
#Numero de Tags o FW utilizados
num   <- vector()
#Media del acierto
media <- vector()

#PCA o SIN-PCA
analisis<-vector()

#######################
##PRUEBAS##############
#######################

#SOLO TAGS SIN PCA
datos   <-c(84.52,95.75,98.23,75.41,81.34,89.09,79.41,85.46,91.72,93.01,63.63,83.46,70.90,87.09)
type[1] <- "TAGS"
num[1]     <- 40
media[1]<- toString(mean(datos))
analisis[1]<- "SIN-PCA"
type[2] <- "FW"
num[2]     <- 0
media[2]<- toString(mean(datos))
analisis[2]<- "SIN-PCA"

#SOLO TAGS CON PCA
datos   <-c(83.77,93.93,96.47,75.41,80.42,95.75,94.11,85.90,90.29,94.62,76.36,90.32,50.90,88.38)
type[3] <- "TAGS"
num[3]     <- 40
media[3]<- toString(mean(datos))
analisis[3]<- "CON-PCA"
type[4] <- "FW"
num[4]     <- 0
media[4]<- toString(mean(datos))
analisis[4]<- "CON-PCA"

#SOLO FW SIN PCA
datos   <-c(76.63,99.39,96.47,97.76,86.87,90.51,90.90,67.64,97.79,98.50,81.72,90.90,83.87,63.63,89.67)
type[5] <- "TAGS"
num[5]     <- 0
media[5]<- toString(mean(datos))
analisis[5]<- "SIN-PCA"
type[6] <- "FW"
num[6]     <- 40
media[6]<- toString(mean(datos))
analisis[6]<- "SIN-PCA"

#SOLO FW CON PCA
datos   <-c(63.01,94.54,89.42,94.02,70.11,65.13,86.66,58.82,88.48,69.40,80.64,81.81,69.35,85.45,78.76)
type[7] <- "TAGS"
num[7]     <- 0
media[7]<- toString(mean(datos))
analisis[7]<- "CON-PCA"
type[8] <- "FW"
num[8]     <- 40
media[8]<- toString(mean(datos))
analisis[8]<- "CON-PCA"

#40FW y 40 TAGS sin PCA
datos   <-c(89.81,99.39,95.59,97.01,90.22,87.46,98.18,79.41,96.47,98.50,96.23,92.72,91.93,87.27,89.67)
type[9] <- "TAGS"
num[9]     <- 40
media[9]<-toString(mean(datos))
analisis[9]<- "SIN-PCA"
type[10] <- "FW"
num[10]     <- 40
media[10]<- toString(mean(datos))
analisis[10]<- "SIN-PCA"

#40FW y 40 TAGS con PCA
datos   <-c(60.75,94.54,91.18,93.28,72.62,62.69,91.51,52.94,85.46,94.02,80.64,83.63,60.48,74.54,68.38)
type[11] <- "TAGS"
num[11]     <- 0
media[11]<- toString(mean(datos))
analisis[11]<- "CON-PCA"
type[12] <- "FW"
num[12]     <- 40
media[12]<- toString(mean(datos))
analisis[12]<- "CON-PCA"



########################
#GRAFICO################
########################
df <-  data.frame(Tipo=type[which(analisis=="SIN-PCA")],Numero=num[which(analisis=="SIN-PCA")],Efectividad=media[which(analisis=="SIN-PCA")])
df.pca<- data.frame(Tipo=type[which(analisis=="CON-PCA")],Numero=num[which(analisis=="CON-PCA")],Efectividad=media[which(analisis=="CON-PCA")])
ggplot(df,aes(x=Efectividad,y=Numero, fill=Tipo)) + geom_bar(position="dodge",stat="identity",colour="black") + ggtitle("Resultados sin PCA variando número de características de entreno") + xlab("Rendimiento (%)") +ylab("Número de características")+labs(fill="Tipo de Caracterísitica")+scale_fill_discrete(labels=c("Palabras funcionales","TAGS"))
