library(ggplot2)
library(gcookbook)

##################################################
#Comparativa entre grupos de 2,3,4,5 y 6 autores##
##################################################

df <- data.frame()
#Grupos de 2 autores
Datos<- c(89.81,99.39,95.59,97.01,90.22,87.46,98.18,79.41,96.47,98.50,96.23,92.72,91.93,87.27,89.67)
df.aux<-as.data.frame(Datos)
df.aux[,"Autores"] <- 2
df <- df.aux
#Grupos de 3 autores
Datos  <- c(81.47,83.01,86.33,86.33,86.46,89,89,84.88,86.04,92.05,86.61,88.28,88.8,88.67,89.81,91.80,92.11,94.08,93.95,80.55)
df.aux<-as.data.frame(Datos)
df.aux[,"Autores"] <- 3
df <- rbind(df,df.aux)
#Grupos de 4 autores
Datos   <- c(80.95,79.33,81.09,81.30,81.15,81.93,84.48,83.75,85,86.62,84.42,85.47,85.96,86.17,89.09)
df.aux<-as.data.frame(Datos)
df.aux[,"Autores"] <- 4
df <- rbind(df,df.aux)
#Grupos de 5 autores
Datos   <- c(77.92,78.67,79.96,79.69,75.66,79.78)
df.aux<-as.data.frame(Datos)
df.aux[,"Autores"] <- 5
df <- rbind(df,df.aux)
#Grupos de 6 autores
Datos   <- c(72.48)
df.aux<-as.data.frame(Datos)
df.aux[,"Autores"] <- 6
df <- rbind(df,df.aux)

#######################
#     GRÁFICO       ###
#######################
ggplot(df,aes(x=factor(Autores),y=Datos, fill=factor(Autores))) + geom_boxplot() + stat_summary(fun.y="mean", geom="point", shape=23, size=3, fill="white") + scale_fill_brewer(palette="Pastel2", limits=c(2,3,4,5,6), labels=c("2 Autores","3 autores", "4 autores", "5 autores" , "6 autores" ))+ylim(50,100)+ xlab("Número de autores") +ylab("Precisión (%)")+labs(fill="Número de autores en la prueba")
