#Modelo SVM
#Cargo las librerias que voy a utilizar
library(e1071)
library(rpart)
#library(partykit)
#library(ada)
#library(randomForest)
library(nnet)
library(MASS)

#library(kernlab)

#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")
#name<-"MIGUEL_DELIBES-CARLOS_RUIZ_ZAFON"
#num_firma <- 80
#k<-3
#---------------------------------------------------vector.prioridades <- vector()

#total <- num_firma
#vector.prioridades <- vector()
#for(i in 1: num_firma){
#  vector.prioridades[i]<-total
#  total <- total - 1
#}
#vector.prioridades  <- vector.prioridades/num_firma

#Uso variable para detectar errores
error <- 0
print("Cargando documentos de test...")
pesos.test <- read.table("Model/Test/pesos.dat", header=TRUE, sep="\t")
print("Carga OK")
print("Cargando documentos de train...") 
pesos.train<- read.table("Model/Train/pesos.dat", header=TRUE, sep="\t")
print("OK")
num_firma <- num_firma + 1
num_muestras_grupo <- floor(nrow(pesos.train)/k)
sobrantes <- nrow(pesos.train) - (num_muestras_grupo*k)
num_observaciones<- nrow(pesos.train)

#Si se crean los modelos con analisis PCA
if(pca == 1){
  
  dir <- paste("PCA/",name.pca,"/PCAvector.Rdata",sep="")
  print("Cargando vector para analisis PCA...")
  load(dir)
  #Procesado de datos
  pesos.train.pr <- as.data.frame(as.matrix(pesos.train[,-num_firma]) %*% eigen.vector)
  pesos.test.pr  <- as.data.frame(as.matrix(pesos.test[,-num_firma]) %*% eigen.vector)
  #Añado autores
  pesos.train <- cbind(pesos.train.pr, Sujeto=pesos.train[,num_firma])
  pesos.test <- cbind(pesos.test.pr, Sujeto=pesos.test[,num_firma])
  num_firma <- num_firma_pr + 1
  
}

#Obtengo los grupos para proceso k-fold-cross validation
 grupos <- list(data.frame())
 contador <- 1
 observaciones <- 1
#Hay que crear grupos con una distribución
#lo más aleatoria posible

seq1 <- round(num_muestras_grupo*(2/3))
seq2 <- num_muestras_grupo- seq1
grupos[[1]] <- pesos.train[c(1:seq1,num_observaciones:(num_observaciones-seq2+1)),]
contador <- seq1 + 1
num_observaciones <- num_observaciones - seq2
grupos[[2]] <- pesos.train[c(contador:(contador+seq2),num_observaciones:(num_observaciones-seq1+1)),]

contador <- contador + seq2 + 1
num_observaciones <- num_observaciones - seq1
for(i in 3:k){ 
  
  if(i%%2!=0){
  grupos[[i]] <- pesos.train[contador,]
  contador  <- contador + 1
  if(sobrantes>0){  
    
    while(nrow(grupos[[i]])<=num_muestras_grupo){
      
      if(nrow(grupos[[i]])<=num_muestras_grupo){
      grupos[[i]]<-rbind(grupos[[i]],pesos.train[num_observaciones,])      
      num_observaciones <- num_observaciones - 1
      }
      if(nrow(grupos[[i]])<=num_muestras_grupo){
        grupos[[i]]<-rbind(grupos[[i]],pesos.train[contador,])      
        contador<- contador +1  
      }        
    }    
    sobrantes<- sobrantes - 1
  }else{
    while(nrow(grupos[[i]])<num_muestras_grupo){
      
      if(nrow(grupos[[i]])<num_muestras_grupo){
        grupos[[i]]<-rbind(grupos[[i]],pesos.train[num_observaciones,])      
        num_observaciones <- num_observaciones - 1
      }
      if(nrow(grupos[[i]])<num_muestras_grupo){
        grupos[[i]]<-rbind(grupos[[i]],pesos.train[contador,])      
        contador<- contador +1  
      }       
    }   
 }
  }else{    
    grupos[[i]] <- pesos.train[num_observaciones,]
    num_observaciones <- num_observaciones - 1
    if(sobrantes>0){  
      
      while(nrow(grupos[[i]])<=num_muestras_grupo){
        
        if(nrow(grupos[[i]])<=num_muestras_grupo){
          grupos[[i]]<-rbind(grupos[[i]],pesos.train[contador,])      
          contador<- contador +1  
        } 
        
        if(nrow(grupos[[i]])<=num_muestras_grupo){
          grupos[[i]]<-rbind(grupos[[i]],pesos.train[num_observaciones,])      
          num_observaciones <- num_observaciones - 1
        }
            
      }    
      sobrantes<- sobrantes - 1
    }else{
      while(nrow(grupos[[i]])<num_muestras_grupo){
        
        if(nrow(grupos[[i]])<num_muestras_grupo){
          grupos[[i]]<-rbind(grupos[[i]],pesos.train[contador,])      
          contador<- contador +1  
        }         
        
        if(nrow(grupos[[i]])<num_muestras_grupo){
          grupos[[i]]<-rbind(grupos[[i]],pesos.train[num_observaciones,])      
          num_observaciones <- num_observaciones - 1
        }      
      }   
    }   
        
  }
}
#Modelo SVM
  # Método K-Fold-Cross-Validation
print("Optimizando parametros Gamma y Cost para modelado SVM...")
  #Variables a optimizar: Gamma, Cost y Epsilon
  gamma   <- 2^(-15:3)
  #gamma   <- sort(gamma,decreasing=TRUE)
  #gamma   <- seq(0.0001,0.01,0.0002)
  #cost    <- seq(1,100,10)
  cost     <- 2^(-5:15)  
  epsilon <- 10^(-20:5)
  errores.max <- num_muestras_grupo+1
  gamma.elegido   <-gamma[1]
  cost.elegido    <- 1
  epsilon.elegido <-epsilon[1]
  j<-1
  l<-1

  for(i in 1:length(gamma)){
    
    for(j in 1:length(cost)){
      
    errores.svm <- 0
    for(cont in 1 : k){
      grupos.train <- grupos[-cont]
      cross.test <- as.data.frame(grupos[cont])
      cross.train <- grupos.train[[1]]
      for(cont2 in 2:length(grupos.train)){
        cross.train <- rbind(cross.train,grupos.train[[cont2]])
      }
      svm.model <- svm(Sujeto ~ .,data = cross.train,type="C-classification",kernel="radial",epsilon=epsilon.elegido,gamma=gamma[i],cost=cost[j],cross=k,scale=TRUE)
      svm.pred <- predict(svm.model,cross.test[,-num_firma],type="class")
      table.svm<-table(pred=svm.pred,true=cross.test[,num_firma])
      filas <- dim(table.svm)[1]
      columna <- dim(table.svm)[2]          
      for(fil in 1:filas){
        for(col in 1:columna){
          if(fil != col){
            errores.svm <- errores.svm + table.svm[fil,col]
          }
        }
      }
      
    }
    errores.svm <- errores.svm/k
    
    if(errores.svm < errores.max){
      errores.max     <- errores.svm
      gamma.elegido   <- gamma[i]    
      cost.elegido    <- cost[j]
      print(paste("Gamma: ",gamma.elegido,"Coste: ",cost.elegido))
      print(paste("Error: ",(errores.max/num_muestras_grupo)*100,"%"),sep="")        
      }
    if(errores.svm == errores.max && gamma.elegido < gamma[i]){
      gamma.elegido   <- gamma[i]
      cost.elegido    <- cost[j]
      print(paste("Gamma: ",gamma.elegido,"Coste: ",cost.elegido))
      print(paste("Error: ",(errores.max/num_muestras_grupo)*100,"%"),sep="")        
    }

    }
  }

#Busqueda más precisa de parametro gamma
if(gamma.elegido>1){
  gamma <- seq(gamma.elegido-0.01,gamma.elegido+0.01,0.0002)
}else{
  gamma <- seq(0.0001,0.01,0.0002)
}

for(i in 1:length(gamma)){
  
    
    errores.svm <- 0
    for(cont in 1 : k){
      grupos.train <- grupos[-cont]
      cross.test <- as.data.frame(grupos[cont])
      cross.train <- grupos.train[[1]]
      for(cont2 in 2:length(grupos.train)){
        cross.train <- rbind(cross.train,grupos.train[[cont2]])
      }
      svm.model <- svm(Sujeto ~ .,data = cross.train,type="C-classification",kernel="radial",epsilon=epsilon.elegido,gamma=gamma[i],cost=cost.elegido,cross=k,scale=TRUE)
      svm.pred <- predict(svm.model,cross.test[,-num_firma],type="class")
      table.svm<-table(pred=svm.pred,true=cross.test[,num_firma])
      filas <- dim(table.svm)[1]
      columna <- dim(table.svm)[2]          
      for(fil in 1:filas){
        for(col in 1:columna){
          if(fil != col){
            errores.svm <- errores.svm + table.svm[fil,col]
          }
        }
      }
      
    }
    errores.svm <- errores.svm/k
    
    if(errores.svm < errores.max){
      errores.max     <- errores.svm
      gamma.elegido   <- gamma[i] 
      print(paste("Gamma: ",gamma.elegido,"Coste: ",cost.elegido))
      print(paste("Error: ",(errores.max/num_muestras_grupo)*100,"%"),sep="")        
    }
    if(errores.svm == errores.max && gamma.elegido < gamma[i]){
      gamma.elegido   <- gamma[i]
      print(paste("Gamma: ",gamma.elegido,"Coste: ",cost.elegido))
      print(paste("Error: ",(errores.max/num_muestras_grupo)*100,"%"),sep="")        
    }
    
  }

  if(cost.elegido <10){
    cost <- seq(1,10,0.1)
  }else{
  cost <- seq(cost.elegido-10,cost.elegido+10,0.1)
  }
  for(j in 1:length(cost)){
      
      errores.svm <- 0
      for(cont in 1 : k){
        grupos.train <- grupos[-cont]
        cross.test <- as.data.frame(grupos[cont])
        cross.train <- grupos.train[[1]]
        for(cont2 in 2:length(grupos.train)){
          cross.train <- rbind(cross.train,grupos.train[[cont2]])
        }
        svm.model <- svm(Sujeto ~ .,data = cross.train,type="C-classification",kernel="radial",epsilon=epsilon.elegido,gamma=gamma.elegido,cost=cost[j],cross=k,scale=TRUE)
        svm.pred <- predict(svm.model,cross.test[,-num_firma],type="class")
        table.svm<-table(pred=svm.pred,true=cross.test[,num_firma])
        filas <- dim(table.svm)[1]
        columna <- dim(table.svm)[2]          
        for(fil in 1:filas){
          for(col in 1:columna){
            if(fil != col){
              errores.svm <- errores.svm + table.svm[fil,col]
            }
          }
        }
        
      }
      errores.svm <- errores.svm/k   
      if(errores.svm < errores.max){
        errores.max     <- errores.svm
        cost.elegido    <- cost[j]
        print(paste("Gamma: ",gamma.elegido,"Coste: ",cost.elegido))
        print(paste("Error: ",(errores.max/num_muestras_grupo)*100,"%"),sep="")        
      }
      if(errores.svm == errores.max && cost[j] > cost.elegido){
        cost.elegido    <- (cost[j]+cost.elegido)/2
        print(paste("Gamma: ",gamma.elegido,"Coste: ",cost.elegido))
        print(paste("Error: ",(errores.max/num_muestras_grupo)*100,"%"),sep="")
      }
    
} 

    for(l in 1:length(epsilon)){
        errores.svm <- 0
        for(cont in 1 : k){
          grupos.train <- grupos[-cont]
          cross.test <- as.data.frame(grupos[cont])
          cross.train <- grupos.train[[1]]
          for(cont2 in 2:length(grupos.train)){
            cross.train <- rbind(cross.train,grupos.train[[cont2]])
          }
          svm.model <- svm(Sujeto ~ .,data = cross.train,type="C-classification",kernel="radial",epsilon=epsilon[l],gamma=gamma.elegido,cost=cost.elegido,cross=k,scale=TRUE)
          svm.pred <- predict(svm.model,cross.test[,-num_firma],type="class")
          table.svm<-table(pred=svm.pred,true=cross.test[,num_firma])
          filas <- dim(table.svm)[1]
          columna <- dim(table.svm)[2]          
          for(fil in 1:filas){
            for(col in 1:columna){
              if(fil != col){
                errores.svm <- errores.svm + table.svm[fil,col]
              }
            }
          }
          
        }
        errores.svm <- errores.svm/k
        if(errores.svm < errores.max){
          errores.max     <- errores.svm
          epsilon.elegido <- epsilon[l]
          print(paste("Gamma: ",gamma.elegido,"Coste: ",cost.elegido,"Epsilon: ",epsilon.elegido))
          print(paste("Error: ",(errores.max/num_muestras_grupo)*100,"%"),sep="")        
        }

  }





#tuned <- tune.svm(Sujeto ~ ., data= pesos.train,gamma=seq(0.001,0.02,0.001),cost=seq(1,1.2,0.05),epsilon=10^(-10:-7),cross=k,kernel="radial",scale=TRUE)
#Mediante crossvalidation compruebo
#Cuales son los valores optimos del modelo
#print(tuned)
  
 print("Parametros escogidos tras metodo cross validation")
 print(paste("Gamma: ",gamma.elegido,"Coste: ",cost.elegido,"Epsilon: ",epsilon.elegido))
print("Creando Modelo svm")
svm.model <- svm(Sujeto ~ .,data = pesos.train,type="C-classification",kernel="radial",epsilon=epsilon.elegido,gamma=gamma.elegido,cost=cost.elegido,cross=k,scale=TRUE)
#svm.model <- svm(Sujeto ~ .,data = pesos.train,type="C-classification",kernel="radial",gamma=tuned$best.parameters$gamma,cost= tuned$best.parameters$cost,cross=k)
print("Modelo svm creado!")

print("Bondad de los datos de entreno:")
  svm.pred <- predict(svm.model,pesos.train[,-num_firma],type="class")
  table.svm<-table(pred=svm.pred,true=pesos.train[,num_firma])
  print(table.svm)
  dir.table <-paste("Modelos/",name,"/svm/svm_table_train.txt",sep="")
  write.table(table.svm,dir.table)
print("Bondad de los datos de test:")
  svm.pred <- predict(svm.model,pesos.test[,-num_firma],type="class")
  table.svm<-table(pred=svm.pred,true=pesos.test[,num_firma])
  print(table.svm)
  dir.table <-paste("Modelos/",name,"/svm/svm_table_test.txt",sep="")
  write.table(table.svm,dir.table)
print("Guardando modelo svm")
dir<- paste("Modelos/",name,"/svm/svm.RData",sep="")
save(svm.model, file=dir) 
print("Modelo guardado")
print("Calculando vector de error")
filas <- dim(table.svm)[1]
columna <- dim(table.svm)[2]
if(filas == 1){
  #Si entra ha ocurrido algún error en el proceso de generación del modelo
  print("No ha sido posible generar el modelo de forma correcta")
  error <- 1
}else{
  errores.svm <- 0
  for(j in 1:filas){
    for(i in 1:columna){
      if(j != i){
          errores.svm <- errores.svm + table.svm[j,i]
      }
    }
  }
  
}

#Modelo Redes Neuronales
# Método K-Fold-Cross-Validation
print("Optimizando parametros Size y Decay para modelado Nnet...")
#Variables a optimizar: Gamma, Cost y Epsilon
size  <- (1:5)
decay <- 10^(-20:-1)
max.valor <- max(pesos.train[-num_firma])
rang.valor <-ceiling(1/max.valor)
rang <- seq(rang.valor-4,rang.valor+4,0.25)
errores.max <- ceiling(nrow(pesos.train)/k)
size.elegido   <-size[1]
decay.elegido  <-decay[1]
rang.elegido   <-rang.valor
rm(grupos.train)
rm(cross.test)
rm(cross.train)
print("Optimizando parametro 'size'....")
for(i in 1:length(size)){
  for(j in 1:length(decay)){
  errores.nnet <- 0
  for(cont in 1 : k){
    grupos.train <- grupos[-cont]
    cross.test <- as.data.frame(grupos[cont])
    cross.train <- grupos.train[[1]]
    for(cont2 in 2:length(grupos.train)){
      cross.train <- rbind(cross.train,grupos.train[[cont2]])
    }
   
    nnet.model <- nnet(Sujeto ~ ., data = cross.train,size=size[i],decay=decay[j],rang=rang.elegido,skip=TRUE,MaxNWts=10000,trace=FALSE,maxit=600)
    
    nnet.pred <- predict(nnet.model,cross.test[,-num_firma],type="class")        
    table.nnet<-table(pred=nnet.pred,true=cross.test[,num_firma])
    filas <- dim(table.nnet)[1]
    columna <- dim(table.nnet)[2]          
    for(fil in 1:filas){
      for(col in 1:columna){
        if(fil != col){
          errores.nnet <- errores.nnet + table.nnet[fil,col]
        }
      }
    }
    
  }
  errores.nnet <- errores.nnet/k
  if(errores.nnet< errores.max){
    errores.max     <- errores.nnet
    size.elegido    <- size[i]
    decay.elegido   <- decay[j]
    print(paste("Size: ",size.elegido,"Decay: ",decay.elegido,"Rang: ",rang.elegido))
    print(paste("Error: ",(errores.max/k)*100,"%"),sep="")        
  }
  if(errores.nnet==errores.max){    
    if(size.elegido < size[i] || (size.elegido==size[i] && decay.elegido>decay[j])){
      size.elegido <- size[i]
      decay.elegido   <- decay[j]
      print(paste("Size: ",size.elegido,"Decay: ",decay.elegido,"Rang: ",rang.elegido))
      print(paste("Error: ",(errores.max/k)*100,"%"),sep="")        
    }      
   
    }

  }

}
print("Optimizando parametro 'decay'....")
decay <- seq(decay.elegido,decay.elegido*100,decay.elegido*2)
  for(j in 1:length(decay)){
    
    errores.nnet <- 0
    for(cont in 1 : k){
      grupos.train <- grupos[-cont]
      cross.test <- as.data.frame(grupos[cont])
      cross.train <- grupos.train[[1]]
      for(cont2 in 2:length(grupos.train)){
        cross.train <- rbind(cross.train,grupos.train[[cont2]])
      }          

      nnet.model <- nnet(Sujeto ~ ., data = cross.train,size=size.elegido,decay=decay[j],rang=rang.elegido,skip=TRUE,MaxNWts=10000,trace=FALSE,maxit=600)
      nnet.pred <- predict(nnet.model,cross.test[,-num_firma],type="class")        
      table.nnet<-table(pred=nnet.pred,true=cross.test[,num_firma])
      filas <- dim(table.nnet)[1]
      columna <- dim(table.nnet)[2]          
      for(fil in 1:filas){
        for(col in 1:columna){
          if(fil != col){
            errores.nnet <- errores.nnet + table.nnet[fil,col]
          }
        }
      }
      
    }
    errores.nnet <- errores.nnet/k
    if(errores.nnet<errores.max){
      errores.max     <- errores.nnet
      decay.elegido   <- decay[j] 
      tabla.elegida   <- table.nnet
      print(paste("Size: ",size.elegido,"Decay: ",decay.elegido,"Rang: ",rang.elegido))
      print(paste("Error: ",(errores.max/k)*100,"%"),sep="")        
    }
    
    if(decay.elegido>decay[j] && errores.nnet==errores.max){
      decay.elegido   <- decay[j] 
      tabla.elegida   <- table.nnet
      print(paste("Size: ",size.elegido,"Decay: ",decay.elegido,"Rang: ",rang.elegido))
      print(paste("Error: ",(errores.max/k)*100,"%"),sep="")        
    }
    
  }
print("Optimizando parametro 'rang'....")    
   for(l in 1:length(rang)){
      errores.nnet <- 0
      for(cont in 1 : k){
        grupos.train <- grupos[-cont]
        cross.test <- as.data.frame(grupos[cont])
        cross.train <- grupos.train[[1]]
        for(cont2 in 2:length(grupos.train)){
          cross.train <- rbind(cross.train,grupos.train[[cont2]])
        }
       
        nnet.model <- nnet(Sujeto ~ ., data = cross.train,size=size.elegido,decay=decay.elegido,rang=rang[l],skip=TRUE,MaxNWts=10000,trace=FALSE,maxit=600)
        nnet.pred <- predict(nnet.model,cross.test[,-num_firma],type="class")        
        table.nnet<-table(pred=nnet.pred,true=cross.test[,num_firma])
        filas <- dim(table.nnet)[1]
        columna <- dim(table.nnet)[2]          
        for(fil in 1:filas){
          for(col in 1:columna){
            if(fil != col){
              errores.nnet <- errores.nnet + table.nnet[fil,col]
            }
          }
        }
        
      }
      errores.nnet <- errores.nnet/k
      if(errores.nnet<errores.max){
        errores.max     <- errores.nnet
        rang.elegido    <- rang[l]
        tabla.elegida   <- table.nnet
        print(paste("Size: ",size.elegido,"Decay: ",decay.elegido,"Rang: ",rang.elegido))
        print(paste("Error: ",(errores.max/k)*100,"%"),sep="")        
      }
    
   }
 

#tuned <- tune.nnet(Sujeto ~ ., data = pesos.train,size=(0:2),decay=10^(-9:-5),rang= seq(rang.valor-1,rang.valor+1,0.25),MaxNWts=10000,skip=TRUE)
#print(tuned)
print("Parametros escogidos tras metodo cross validation")
print(paste("Size: ",size.elegido,"Decay: ",decay.elegido, "Rang: ", rang.elegido))

print("Creando modelo nnet...")
#print(tuned)
#nnet.model <- nnet(Sujeto ~ ., data = pesos.train,size=tuned$best.parameters$size,decay=0,skip=TRUE,MaxNWts=10000,trace=FALSE,maxit=250)
 
nnet.model <- nnet(Sujeto ~ ., data = pesos.train,size=size.elegido,decay=decay.elegido,skip=FALSE,rang=rang.elegido,MaxNWts=10000,trace=FALSE)

print("Modelo nnet creado!")

print("Bondad de los datos de entreno:")
nnet.pred <- predict(nnet.model,pesos.train[,-num_firma],type="class")
table.nnet<-table(pred=nnet.pred,true=pesos.train[,num_firma])
print(table.nnet)
dir.table <-paste("Modelos/",name,"/neuronal/nnet_table_train.txt",sep="")
write.table(table.nnet,dir.table)

print("Bondad de los datos de test:")
nnet.pred <- predict(nnet.model,pesos.test[,-num_firma],type="class")
table.nnet<-table(pred=nnet.pred,true=pesos.test[,num_firma])
print(table.nnet)
dir.table <-paste("Modelos/",name,"/neuronal/nnet_table_test.txt",sep="")
write.table(table.nnet,dir.table)

print("Guardando modelo nnet")
dir<- paste("Modelos/",name,"/neuronal/nnet.RData",sep="")
save(nnet.model, file=dir) 
print("Modelo guardado")
print("Calculando vector de error")

filas <- dim(table.nnet)[1]
columna <- dim(table.nnet)[2]
if(filas == 1){
  #Si entra ha ocurrido algún error en el proceso de generación del modelo
  print("No ha sido posible generar el modelo de forma correcta")
  error <- 1
}else{
  errores.nnet <- 0
  for(j in 1:filas){
    for(i in 1:columna){
      if(j == i){
        #No se hace nada
      }else{
        errores.nnet <- errores.nnet + table.nnet[j,i]
      }
    }
  }
  
}



#Modelo Naive Bayes

print("Optimizando parametro Laplace para modelado Red bayesiana...")
#Variables a optimizar: Gamma, Cost y Epsilon
laplace  <- c(0,10^(-10:-1))
errores.max <- ceiling(nrow(pesos.train)/k)
laplace.elegido   <-0
rm(grupos.train)
rm(cross.test)
rm(cross.train)
for(i in 1:length(laplace)){  
      errores.bayes <- 0
      for(cont in 1 : k){
        grupos.train <- grupos[-cont]
        cross.test <- as.data.frame(grupos[cont])
        cross.train <- grupos.train[[1]]
        for(cont2 in 2:length(grupos.train)){
          cross.train <- rbind(cross.train,grupos.train[[cont2]])
        }
        bayes.model <- naiveBayes(Sujeto ~ ., data = cross.train,laplace=laplace[i])
        bayes.pred <- predict(bayes.model,cross.test[,-num_firma],type="class")
        table.bayes<-table(pred=bayes.pred,true=cross.test[,num_firma])
        filas <- dim(table.bayes)[1]
        columna <- dim(table.bayes)[2]          
        for(fil in 1:filas){
          for(col in 1:columna){
            if(fil != col){
              errores.bayes <- errores.bayes + table.bayes[fil,col]
            }
          }
        }
        
      }
      errores.bayes <- errores.bayes/k
      if(errores.bayes< errores.max){
        errores.max     <- errores.bayes
        laplace.elegido    <- laplace[i]   
        tabla.elegida   <- table.bayes
        print(paste("Laplace: ",laplace.elegido))
        print(paste("Error: ",(errores.max/k)*100,"%"),sep="")        
      }

}

print("Parametros escogidos tras metodo cross validation")
print(paste("Laplace: ",laplace.elegido))

print("Creando modelo bayes...")
bayes.model <- naiveBayes(Sujeto ~ ., data = pesos.train,laplace=laplace.elegido)
print("Modelo bayes creado!")

print("Bondad de los datos de entreno:")
bayes.pred <- predict(bayes.model,pesos.train[,-num_firma],type="class")
table.bayes<-table(pred=bayes.pred,true=pesos.train[,num_firma])
print(table.bayes)
dir.table <-paste("Modelos/",name,"/Bayes/bayes_table_train.txt",sep="")
write.table(table.bayes,dir.table)

print("Bondad de los datos de test:")
bayes.pred <- predict(bayes.model,pesos.test[,-num_firma],type="class")
table.bayes<-table(pred=bayes.pred,true=pesos.test[,num_firma])
print(table.bayes)
dir.table <-paste("Modelos/",name,"/Bayes/bayes_table_test.txt",sep="")
write.table(table.bayes,dir.table)

print("Guardando modelo bayes")
dir<- paste("Modelos/",name,"/Bayes/bayes.RData",sep="")
save(bayes.model, file=dir) 
print("Modelo guardado")

print("Calculando vector de error...")
filas <- dim(table.bayes)[1]
columna <- dim(table.bayes)[2]
if(filas == 1){
  #Si entra ha ocurrido algún error en el proceso de generación del modelo
  print("No ha sido posible generar el modelo de forma correcta")
  error <- 1
}else{
  errores.bayes <- 0
  for(j in 1:filas){
    for(i in 1:columna){
      if(j == i){
        #No se hace nada
      }else{
        errores.bayes <- errores.bayes + table.bayes[j,i]
      }
    }
  }
  
}

#lda.model <- lda(Sujeto ~ ., data = pesos.train)
#lda.pred <- predict(lda.model,pesos.test[,-num_firma],type="class")
#table.lda<-table(pred=lda.pred$class,true=pesos.test[,num_firma])
#print(table.lda)

df.errores<- as.data.frame(t(c(bayes.model=errores.bayes,nnet.model=errores.nnet,svm.model=errores.svm)))
df.errores<-sort(df.errores,decreasing=FALSE)
vector.errores <- names(df.errores)
if(error == 0){
  print("Modelos creados correctamente , FIN")
  
}
if(error == 1){
  print("No se han podido generar alguno/s de los modelos correctamente")
}
dir<- paste("Modelos/",name,"/v_error/vector_error.RData",sep="")
save(vector.errores,file=dir)
rm(list=ls())