package Test;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import Utilities.CreateTagMatrix;
import Utilities.findTagSign;
public class testFindTagSign {


	
	private final static Logger logger = Logger.getLogger(findTagSign.class.getName());
	private static File documento=new File("./Documentos/Pablo/results_Test/texto9.txt"); 
	private static String name ="Pablo";
	private static List<String> Sign = new ArrayList();
	private static CreateTagMatrix tagMatrix = new CreateTagMatrix();

	private void getSignFromFile() throws IOException{
		
		File sign_file = new File("");
		String path = sign_file.getPath();
		BufferedReader reader = new BufferedReader(new FileReader(path+"/Documentos/"+name+"/Firma/firma.dat"));
		String line= new  String();
		while((line = reader.readLine()) != null){
			Sign.add(line);
		}
				
	}
	
	
	final static public void main (String Args[]) throws IOException{
	
		//Primero obtenemos los Tags que identifican al usuario
		File sign_file = new File("");
		String path = sign_file.getAbsolutePath();
		BufferedReader reader = new BufferedReader(new FileReader(path+"/Documentos/"+name+"/Firma/firma.dat"));
		String line= new  String();
		while((line = reader.readLine()) != null){
			Sign.add(line);
		}		
		
		//Ahora cargamos en memoria el documento y
		//comprobamos uno a uno la frecuencia "normalizada" de los Tags presentes firma
		reader = new BufferedReader(new FileReader(documento));
		
		int contador,palabras = 0;
		
		List<Integer> freq = new ArrayList();
		List<Float> freq_norm = new ArrayList(); 
		//Cuento el numero de palabaras que tiene el documento
		//Para normalizar el resultado
		
		while(( line = reader.readLine())!=null){
			palabras += line.split(" ").length;
		}
		reader.close();
		
		int apariciones;
		//Obtengo la matriz de Tags para luego comparar con la firma
		StringBuffer matrizTags = tagMatrix.createMatrix(documento);
		
		//Vuelvo  a recorrer el documento y cuento las apariciones que hay
		//de cada uno de los Tags
		
		String Tags = matrizTags.toString().toLowerCase();
	
			for(contador=0;contador<100;contador++){
				apariciones = 0;
				String regex = Sign.get(contador);
				Pattern regPatt = Pattern.compile(regex);
				Matcher regMatch = regPatt.matcher(Tags);
				while(regMatch.find()){
				apariciones++;	
				}
				freq.add(apariciones);
			}
		
		
		//Recorro la lista de frecuencias no normalizadas
		//y la divido entre la longitud del documento 
		//para conseguir la normalizacion
		for(contador=0;contador<100;contador++){			 
			freq_norm.add((float)freq.get(contador)/palabras);
			}
	
		}
		
}