library(ggplot2)
library(gcookbook)


df<- data.frame()

#############################
#Autor 1
modelo  <- as.factor("MM-MJ")
gamma   <- 0.0078125
cost    <- 0.03125
epsilon <- 9.53e-07
size    <- 1
decay   <- 0.003
rang    <- 9
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df <- df.aux

#Autor 2
modelo  <- as.factor("MM-FJP")
gamma   <- 0.0078125
  cost  <- 1
  epsilon <- 9.53e-07
  size    <- 2 
  decay   <- 0.01
  rang    <- 9
  laplace <- 0
  df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 3
modelo  <- as.factor("MJ-FJP")
gamma   <- 0.0078125
cost  <- 1
epsilon <- 9.53e-07
size    <- 2 
decay   <- 1e-04
rang    <- 9
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 4
modelo  <- as.factor("MD-MM")
gamma   <- 0.017625
cost  <- 2
epsilon <- 9.53e-07
size    <- 6 
decay   <- 1e-16
rang    <- 12
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 5
modelo  <- as.factor("MD-MJ")
gamma   <- 0.00390625
cost  <- 8
epsilon <- 9.53e-07
size    <- 4 
decay   <- 1e-13
rang    <- 9
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 6
modelo  <- as.factor("MD-FJP")
gamma   <- 0.03125
cost  <- 1
epsilon <- 9.53e-07
size    <- 1
decay   <- 0.0019
rang    <- 9
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 7
modelo  <- as.factor("MD-CRZ")
gamma   <- 0.00390625
cost  <- 2
epsilon <- 9.53e-07
size    <- 4 
decay   <- 1e-15
rang    <- 9
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 8
modelo  <- as.factor("MD-APR")
gamma   <- 0.00390625
cost  <- 8
epsilon <- 9.53e-07
size    <- 2 
decay   <- 1e-7
rang    <- 11
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 9
modelo  <- as.factor("CRZ-MM")
gamma   <- 0.03125
cost  <- 1
epsilon <- 9.53e-07
size    <- 2 
decay   <- 1e-20
rang    <- 12
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 10
modelo  <- as.factor("CRZ-MJ")
gamma   <- 0.0078125
cost  <- 0.03125
epsilon <- 9.53e-07
size    <- 2 
decay   <- 1e-20
rang    <- 12
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 11
modelo  <- as.factor("CRZ-FJP")
gamma   <- 0.0078125
cost  <- 0.03125
epsilon <- 9.53e-07
size    <- 1 
decay   <- 1e-7
rang    <- 9
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 12
modelo  <- as.factor("APR-MM")
gamma   <- 0.0009765625
cost  <- 32
epsilon <- 9.53e-07
size    <- 2 
decay   <- 5e-4
rang    <- 10
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 13
modelo  <- as.factor("APR-MJ")
gamma   <- 0.0009765625
cost  <- 0.03125
epsilon <- 9.53e-07
size    <- 2 
decay   <- 9e-5
rang    <- 9
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 14
modelo  <- as.factor("APR-FJP")
gamma   <- 0.0078125
cost  <- 1
epsilon <- 9.53e-07
size    <- 1 
decay   <- 1e-9
rang    <- 9
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

#Autor 15
modelo  <- as.factor("APR-CRZ")
gamma   <- 0.0078125
cost  <- 1
epsilon <- 9.53e-07
size    <- 4
decay   <- 0.001
rang    <- 11
laplace <- 0
df.aux <- data.frame(modelo,gamma,cost,epsilon,size,decay,rang,laplace)  
df<-rbind(df,df.aux)

######################################
#GRÁFICOS#############################
######################################

######################################
#############SVM#####################
######################################
df.svm <- data.frame(df["modelo"],df["cost"],Tipo="coste")
names(df.svm) <- c("Modelo","Valor","Tipo")
ggplot(df.svm,aes(x=Modelo, y=Valor))+geom_point(size=3)+facet_grid(Tipo ~ ., scales="free_y")+ylab("Coste")

df.aux <- data.frame(df["modelo"],df["gamma"],Tipo="gamma")
names(df.aux) <- c("Modelo","Valor","Tipo")
ggplot(df.aux,aes(x=Modelo, y=Valor))+geom_point(size=3)+facet_grid(Tipo ~ ., scales="free_y")+ylab("Gamma")

df.svm <- rbind(df.svm,df.aux)
df.aux <- data.frame(df["modelo"],df["epsilon"],Tipo="epsilon")
names(df.aux) <- c("Modelo","Valor","Tipo")
ggplot(df.aux,aes(x=Modelo, y=Valor))+geom_point(size=3)+facet_grid(Tipo ~ ., scales="free_y")+ylab("Epsilon")
df.svm <- rbind(df.svm,df.aux)
ggplot(df.svm,aes(x=Modelo, y=Valor))+geom_point(size=3)+facet_grid(Tipo ~ ., scales="free_y")+ggtitle("Distribución de las características del modelo SVM") + xlab("Modelos") +ylab("Valor elegido")


######################################
############NERUONAL#################
######################################

df.nnet <- data.frame(df["modelo"],df["rang"],Tipo="rang")
names(df.nnet) <- c("Modelo","Valor","Tipo")
ggplot(df.nnet,aes(x=Modelo, y=Valor))+geom_point(size=3)+facet_grid(Tipo ~ ., scales="free_y")+ xlab("Modelos") +ylab("Rang")

df.aux <- data.frame(df["modelo"],df["size"],Tipo="Numero de neuronas")
names(df.aux) <- c("Modelo","Valor","Tipo")
ggplot(df.aux,aes(x=Modelo, y=Valor))+geom_point(size=3)+facet_grid(Tipo ~ ., scales="free_y")+ xlab("Modelos") +ylab("Número de neuronas")

df.nnet <- rbind(df.nnet,df.aux)
df.aux <- data.frame(df["modelo"],df["decay"],Tipo="decay")
names(df.aux) <- c("Modelo","Valor","Tipo")
ggplot(df.aux,aes(x=Modelo, y=Valor))+geom_point(size=3)+facet_grid(Tipo ~ ., scales="free_y")+ xlab("Modelos") +ylab("Tasa de aprendizaje")

df.nnet <- rbind(df.nnet,df.aux)
ggplot(df.nnet,aes(x=Modelo, y=Valor))+geom_point(size=3)+facet_grid(Tipo ~ ., scales="free_y")+ggtitle("Distribución de las características del modelo de red Neuronal") + xlab("Modelos") +ylab("Valor elegido")

######################################
############BAYES#################
######################################

df.bayes <- data.frame(df["modelo"],df["laplace"],Tipo="laplace")
names(df.bayes) <- c("Modelo","Valor","Tipo")
ggplot(df.bayes,aes(x=Modelo, y=Valor))+geom_point(size=3)+facet_grid(Tipo ~ ., scales="free_y")+ggtitle("Distribución de las características del modelo de red Neuronal") + xlab("Modelos") +ylab("Valor elegido")

