#Script para el calculo
#de la Firma del Sujeto

#Importo las librerias que voy a usar
library("RWeka")
library("tm")

#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")

#---------------------------------------------------
print("OPCION 6 NGRAM")
#FUNCIONES----------------------------------------------------
#Creo funcion que me crea  tokens de dos a seis tags
TFGGramTokenizer <-function(x) NGramTokenizer(x,Weka_control(min=token.min,max=token.max))

checkTerm <- function(termino,vector_terminos){  
  resultado <- 0
  for(long in 1:length(vector_terminos)){
    if(termino == vector_terminos[long]){
      resultado <- 1
    }
  }
  return(resultado)
}
#-----------------------------------------------------------
#DEBUG
#fich.tag.matriz <- "matrizTags_MIGUEL_MORA_FERNANDO_J_PEREZ.dat"
#name <- "MIGUEL_MORA-FERNANDO_J_PEREZ"
#range.valor<-1.2
#plot.box<-FALSE
#num_firma<-40
#token.min<-3
#token.max<-6
#num_outliers_max<-2
########################################################################
dir <- paste("Tags/",fich.tag.matriz,sep="")
matriz_tags <-scan(dir,what=character(0),sep="\n",flush=FALSE, fill=FALSE)
tags<-vector()

matriz <- gsub("\\t"," ", matriz_tags)

#Creo una lista donde separo cada uno de los sujetos
sujeto <- list(list())
sujeto[[1]][1] <- matriz[1]
j <- 1
i<-integer()
col<-2
longitud <- length(matriz)
for(i in 2:longitud){
  if(matriz[i]==","){
    j<-j+1
    col<-1
    sujeto[[j]]<-""
  }else{
    sujeto[[j]][col]<-matriz[i]
    col<-col+1
  }
}
#Guardo en la variable longitud el numero de sujetos
longitud <- length(sujeto)
corpus <- list()
for(i in 1:longitud){
  corpus[[i]] <- Corpus(VectorSource(sujeto[[i]]))
}


#Tengo el corpus de los documentos
#Ahora creo nuevos vectores con los n-gramas
tdm <- list()
tdm.norm <- list()
tdm.norm.05 <- list()
for(i in 1:longitud){
  tdm[[i]] <- TermDocumentMatrix(corpus[[i]][1], control=list(weight= function(x) weightTfIdf(x,normalize=TRUE),tokenize=TFGGramTokenizer))
  mat_dim <- strsplit(corpus[[i]][[1]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
  long = length(mat_dim[[1]])
  tdm.norm[[i]] <- tdm[[i]]
  tdm.norm[[i]]$v <- tdm[[i]]$v/long
  
  for(j in 2:length(corpus[[i]])){
    mat_dim <- strsplit(corpus[[i]][[j]]," ",fixed=FALSE,perl=FALSE,useBytes=FALSE)
    long <- length(mat_dim[[1]])  
    tdm1 <- TermDocumentMatrix(corpus[[i]][j], control=list(weight= function(x) weightSMART(x,spec="ntc"),tokenize=TFGGramTokenizer))
    tdm1.norm <- tdm1
    tdm1.norm$v <- tdm1$v/long 
    tdm.norm[[i]] <- c(tdm.norm[[i]],tdm1.norm)
  }
  tdm.norm.05[[i]] <- removeSparseTerms(tdm.norm[[i]],0.3)
}


tdm.glob <- tdm.norm.05[[1]]
corpus <- list()
for(i in 2:longitud){
  tdm.glob <- c(tdm.glob,tdm.norm.05[[i]])
}




vector.terminos<- tdm.glob$dimnames$Terms
pesos_terms <- list(vector())
lista_terminos <- data.frame()
pesos_box <-list()
pesos <- 1
#Calculo el area del box plot
dir2<- paste("Firma/",name,"/Terminos_area.dat",sep="")
write("CALCULO DE LAS AREAS DE LOS TERMINOS\n\n",file=dir2,append=FALSE)  

  texto <- paste("\nProceso de selecion de terminos")
  print(texto)
  write(texto,file=dir2,append=TRUE)
  lista_terminos<-0
  out_box<-0
  
  #True para imprimir los boxplot(DEBUG) FALSE para no  hacerlo(PRODUCCIÓN)
  #plot.estado<-FALSE #DEBUG
  #range.valor: Precisión de los "bigotes" de los boxplots para hacer más estrictos los outliers
  if(range.valor<1){
    print("Valor incorrecto para los bigotes del boxplot, recuerde debe ser un valor mayor que cero.")
    print("Imposible continuar, firma no creada")
  }else{
  
  for(i in 1:length(vector.terminos)){  
      
        outliers <- FALSE  
        pesos_box <-list()
        for(sujeto in 1:longitud){     
          
            resultado <- 0
            resultado = checkTerm(vector.terminos[i],tdm.norm.05[[sujeto]]$dimnames$Terms)
            if(resultado == 1){
              box_sujeto <- boxplot(as.vector(inspect(tdm.norm.05[[sujeto]][vector.terminos[i],dimnames(tdm.norm.05[[sujeto]])$Docs])),plot=plot.estado,range=range.valor)
              pesos_box[[sujeto]]<-  box_sujeto$stats[,1]
              out_box_sujeto <- length(box_sujeto$out)
              if(out_box_sujeto>num_outliers_max){
                outliers <- TRUE
              }
            }else{
              pesos_box[[sujeto]] <- c(0,0,0,0,0)
              #contador <- contador + 1
            }
          
          
        }
        if(outliers==FALSE){
        vector_medidas_alta <- vector()
        vector_medidas_baja <- vector()
        #Calculo el area entre los box plot
          for(suj in 1:longitud){
          
                vector_medidas_alta[suj] <-  pesos_box[[suj]][4]
                vector_medidas_baja[suj] <-  pesos_box[[suj]][2]             
            
          }
          area<-0
          indice1<- which(vector_medidas_alta == max(vector_medidas_alta))
          x1 <- vector_medidas_alta[indice1]
          y1 <- vector_medidas_baja[indice1]
          vector_medidas_alta[indice1] <- (-100)
          vector_medidas_baja[indice1] <- (-100)
          for(indices in 2:longitud){
            indice2 <- which(vector_medidas_alta == max(vector_medidas_alta))[1]
            x2 <- vector_medidas_alta[indice2]
            y2 <- vector_medidas_baja[indice2]
            vector_medidas_alta[indice2] <- (-100)
            vector_medidas_baja[indice2] <- (-100)
            #Calculo area
            area.nueva <- (x1 - x2)
            area <- area +  area.nueva
            #Calculo nuevo cuadrado
            if(x2 <= y1 ){
              x1 <- x2
              y1 <- y2
            }else if(y1 >= y2){
              x1 <- y1
              y1 <- y2
            }else{
              x1 <- y2        
            }
            for(iterador in 1:length(vector_medidas_alta)){
              if(vector_medidas_alta[iterador]>x1){
                vector_medidas_alta[iterador] <- x1
              }
            }
          }
          area.nueva <-  (x1 -y1)
          area <- area + area.nueva
          #print(texto)
        }else{
          area<-0
        }        
  
      texto <- paste("Termino: ",vector.terminos[i]," Area: ",area)
      lista_terminos[vector.terminos[i]] <- data.frame(area)
      write(texto,file=dir2,append=TRUE) 
  }



#Numero de grupos en la firma
#num_firma <-  40
tdm_elegidas <- vector()
termino <- 1


  v.ter <- as.data.frame(lista_terminos)
  v.ter <-sort(v.ter,decreasing=TRUE)
  contador <- 1
  for(iterador in 1:length(v.ter)){
    if(contador > num_firma){
      break;
    }
    if(termino == 1){
      ter <- names(v.ter[iterador])
      ter <- gsub('\\.'," ",ter)
     if(grepl("z",strsplit(ter,"\\."))){
       #No se hace nada se pasa al siguiente termino
     }else{
      tdm_elegidas[1]<- ter  
      termino <- termino + 1
      contador <- contador + 1
     }
    }else{
      encontrado <- 0
      ter <- names(v.ter[iterador])
      ter <- gsub('\\.'," ",ter)
      for(j in 1:length(tdm_elegidas)){      

        if(tdm_elegidas[j]==ter){
          encontrado <- 1
          break;
        }
      }
      if(encontrado==0){
        if(grepl("z",strsplit(ter,"\\."))){
          #No se hace nada, se pasa al siguiente
        }else{
        tdm_elegidas[termino]<- ter  
        termino <- termino + 1
        contador <- contador + 1
        }
      }
    }
  }

direccion = paste("Firma/",name,"/firma.dat",sep="")
tags <- tdm_elegidas[1:num_firma]
write(as.vector(tags),file=direccion,append=FALSE)
print("Firma creada correctamente")
}
