#Analisis PCA de un documento

library(FactoMineR)

#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Chooser")
#name<-"MIGUEL_MORA-FERNANDO_J_PEREZ"
#########################################################
#num_firma <-80
#num_PCA <-5
if(!exists("name")){
  print("Nombre de autores no introducido")  
}else{
print("Cargando documentos de train...") 
pesos.train<- read.table("Model/Train/pesos.dat", header=TRUE, sep="\t")
print("OK")
num_firma <- num_firma + 1

pca.analisis <- prcomp(pesos.train[,-num_firma], cor=TRUE,retx=TRUE,center=FALSE,scale =FALSE)
train <- as.matrix(pesos.train[,-num_firma])

scores<-pca.analisis$x
eigen.vector <- pca.analisis$rotation


#Imprimo barplot
dir2 <- paste("PCA/",name,"/Barplot.png",sep="")
importance <- summary(pca.analisis)$importance
png(filename=dir2)
barplot(importance[2,],main="Barplot de las Componentes Principales",col="red")
dev.off()
#Guardo vector resultado para posterior analisis PCA
dir <- paste("PCA/",name,"/PCAvector.Rdata",sep="")
eigen.vector <- eigen.vector[,1:num_PCA]
pesos.calculados  <-   train %*% eigen.vector
save(eigen.vector,file=dir)
}

