#Script para el calculo
#de las palabras funcionales

#Importo las librerias que voy a usar
#library("RWeka")
#library("tm")

#PARA DEBUG----------------------------------------
#setwd("/home/alejandro/workspace/TFG-Authorship-Attribution/Documentos")
#autor<-"MIGUEL_MORA"
#---------------------------------------------------

dir <- paste(autor,"/results_Train/",sep="")
#Cargos los textos del directorio
textos <- Corpus(DirSource(dir,encoding="UTF-8"))
#Paso a minusculas todas las palabras para que no halla ningun problema
textos <- tm_map(textos,tolower)
if(exists("lista.stop.words")){
 
  textos <- tm_map(textos,removeWords,lista.stop.words)
}
#Creo la matriz de terminos
  #Compruebo que la matriz existe
if(exists("dtm")){
  #Si existe la concateno con la anterior
  dtm<-c(dtm,TermDocumentMatrix(textos,control = list(stopwords=FALSE,wordLengths=c(0,Inf))))
}else{
  dtm <- TermDocumentMatrix(textos,control = list(stopwords=FALSE,wordLengths=c(0,Inf)))
}
